#!/bin/bash
## This demo creates a ~/.kunf/bash file and modifies the ~/.bashrc file
## allowing the user to set options from kunfedit

echo "------------------------------------------------------------------"
echo "This demo will modify your .bashrc file so that you can set some"
echo "of your preferences via kunfedit"
echo "------------------------------------------------------------------"
sleep 3
if [ -x /usr/bin/kunfenv ] ; then
  echo "Creating ~/.kunf directory"
  cd ~
  mkdir .kunf
  echo "------------------------------------------------------------------"
  echo "Creating ~/.kunf/bash file"
  cd .kunf
  > bash
  if [ $PATH != "" ] ; then
    echo "path=\"$PATH\"" >> bash
  fi
  if [ $MAILPATH != "" ] ; then
    echo "mailpath=\"$MAILPATH\"" >> bash
  fi
  if [ $MAILCHECK != "" ] ; then 
    echo "mailcheck=\"$MAILCHECK\"" >> bash
  fi
  if [ $PS1 != "" ] ; then 
    echo "primaryprompt=\"$PS1\"" >> bash
  fi
  if [ $PS2 != "" ] ; then 
    echo "secondaryprompt=\"$PS2\"" >> bash
  fi
  if [ $PS3 != "" ] ; then 
    echo "tertiaryprompt=\"$PS3\"" >> bash
  fi
  if [ $HISTSIZE != "" ] ; then 
    echo "histsize=\"$HISTSIZE\"" >> bash
  fi
  if [ $HISTFILE != "" ] ; then 
    echo "histfile=\"$HISTFILE\"" >> bash
  fi
  if [ $HISTFILESIZE != "" ] ; then 
    echo "histfilesize=\"$HISTFILESIZE\"" >> bash
  fi
  echo "------------------------------------------------------------------"
  cd ~
  if [ -r .bashrc ] ; then
    echo "Saving old .bashrc to .bashrc.nokunf"
    cp .bashrc .bashrc.nokunf
    echo "------------------------------------------------------------------"
  fi
  echo "Appending to ~/.bashrc"
  echo "# The lines below were added by the kunf demo" >> .bashrc
  echo "eval \`/usr/bin/kunfenv shells:bash\`" >> .bashrc
  echo "export PATH=\$path" >> .bashrc
  echo "export MAILPATH=\$shells_bash_mailpath" >> .bashrc
  echo "export MAILCHECK=\$shells_bash_mailcheck" >> .bashrc
  echo "export PS1=\$shells_bash_primaryprompt" >> .bashrc
  echo "export PS2=\$shells_bash_secondaryprompt" >> .bashrc
  echo "export PS3=\$shells_bash_tertiaryprompt" >> .bashrc
  echo "export HISTSIZE=\$shells_bash_histsize" >> .bashrc
  echo "export HISTFILE=\$shells_bash_histfile" >> .bashrc
  echo "export HISTFILESIZE=\$shells_bash_histfilesize" >> .bashrc
  echo "------------------------------------------------------------------"
  if [ -x /usr/bin/kunfedit ] ; then 
    echo "Kunfedit will now start. Select the menu entry shells:bash"
    echo "and change the options listed there to suit your tastes"
    echo "------------------------------------------------------------------"
    sleep 3
    echo "Strike <Enter> to continue..." 
    read
    /usr/bin/kunfedit
  else 
    echo "Please run kunfedit manually to set up shells:bash"
    echo "I can not find kunfedit myself..."
    echo "------------------------------------------------------------------"
  fi
else
  echo "Error: It seems kunf(env) is not installed. I will not proceed"
  echo "------------------------------------------------------------------"
  echo "To install type:"
  echo ""
  echo "  make install"
  echo "" 
  echo "as superuser from the directory which was created by the archive"
  echo "------------------------------------------------------------------"
fi
