/* this is the code for the the C example on page examples.html */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>  /* for getpid() */

#include <kunf.h>    /* include the function declarations */

int main(){

  char *str;         /* pointer to the returned string */ 

  /* WARNING : The call to kunfig_open is NOT the same as in */
  /* the example. You should _ALMOST_ALWAYS_ set the first   */
  /* parameter to NULL. I have only used a different root    */
  /* since you might not have installed kunf yet and because */
  /* you would never want to have it as part of your real    */
  /* configuration tree. getpid() is used as a pseudo-random */
  /* number generator. For real programs you would never     */
  /* want to randomly change the location of configuration   */
  /* files - Here it only illustrates the options you have.  */

  if(getpid()%2)kunfig_open("etc.distributed/root.kunf",KUNFIG_OPEN_STANDARD);
  else          kunfig_open("etc.single/root.kunf",KUNFIG_OPEN_STANDARD);  
  /* In real life you should rather do something like:       */
  /* kunfig_open(NULL,KUNFIG_OPEN_STANDARD);                 */

  str=kunfig_findvalue(4,"mail","foo","interface","fgcolor");

  /* now use the value of str to get the foreground colour   */
  /* but do check that str!=NULL (printf also does that), and*/
  /* fall back on internal values if str==NULL. Do not use   */
  /* free(str). */
  printf("My mail:foo:interface:foreground is: <%s>\n",str);

  str=kunfig_findvalue(4,"mail","foo","interface","bgcolor");

  /* now use str to determine background colour */
  printf("My mail:foo:interface:background is: <%s>\n",str);

  str=kunfig_findvalue(4,"mail","foo","identity","name");
  printf("My mail:foo:identity:name is: <%s>\n",str);

  str=kunfig_findvalue(4,"mail","foo","identity","signature");
  printf("My mail:foo:identity:signature is: <%s>\n",str);

  str=kunfig_findvalue(4,"mail","foo","identity","replyto");
  printf("My mail:foo:identity:replyto is: <%s>\n",str);

  str=kunfig_findvalue(4,"mail","foo","backend","mailbox");
  printf("My mail:foo:backend:mailbox is: <%s>\n",str);

  str=kunfig_findvalue(4,"mail","foo","backend","tmpdir");
  printf("My mail:foo:backend:tmpdir is: <%s>\n",str);
 
  kunfig_close();   

  /* at this point all values returned by kunfig_findvalue */ 
  /* have become invalid (they have been deallocated) */

  return 0;
}
