#!/bin/sh
## 
## This script will append a line to your /etc/profile
## to call kunfenv to set up your NNTPSERVER environment
## variable. This means you can use kunfedit to set 
## your nntpserver (in news:nntp)
##
## You will have to be root to run this script
##
## For (t)csh users one could add the following two lines:
# eval `/usr/bin/kunfenv news:nntp:nntpserver` 
# setenv NNTPSERVER $news_nntp_nntpserver
## to the file /etc/csh.login 

echo "------------------------------------------------------------------"
echo "This program will modify /etc/profile to allow the"
echo "NNTPSERVER variable to be set from kunfedit..."
echo "------------------------------------------------------------------"

## Check if we can write to /etc/profile 
if [ `whoami` = "root" ] ; then 

  sleep 1

  ## Check if the kunf library has been installed
  if [ -x /usr/bin/kunfenv ] ; then

    ## Append to /etc/profile
    echo "# The line below was added by the kunf demo" >> /etc/profile
    echo "eval \`/usr/bin/kunfenv news:nntp:nntpserver\` ; export NNTPSERVER=\$news_nntp_nntpserver" >> /etc/profile

    echo "Appended two lines to /etc/profile to set NNTPSERVER variable"
    echo "------------------------------------------------------------------"

    ## Ask the user to select a value for the NNTPSERVER 
    if [ -x /usr/bin/kunfedit ] ; then 
      echo "Kunfedit will now start. Edit the menu entry news:nntp:nntpserver"
      echo "and change it to a valid value (ie the name of an NNTP host)."
      echo "Thereafter all login shells (of the sh family) will have"
      echo "the NNTPSERVER variable set to the value you entered there."
      echo "------------------------------------------------------------------"
      sleep 3
      echo "Strike <Enter> to continue..." 
      read
      /usr/bin/kunfedit
    else 
      echo "Please run kunfedit manually to set up news:nntp:nntpserver"
      echo "I can not find kunfedit myself..."
      echo "------------------------------------------------------------------"
    fi
  else
    echo "Error: It seems kunf(env) is not installed. I will not proceed"
    echo "------------------------------------------------------------------"
    echo "To install type:"
    echo ""
    echo "  make install"
    echo "" 
    echo "as superuser from the directory which was created by the archive"
    echo "------------------------------------------------------------------"
  fi

else
  echo "Error: Please run me as root..."
  echo "------------------------------------------------------------------"
fi
