/** This file is copyrighted (c) and may only be used in terms of the LGPL **/

#ifndef _internalkunf_h_
#define _internalkunf_h_

#include <syslog.h>

/****************************************************************************/
/* Well, if you have to fiddle these values then do so - but I won't like it*/

#define SCANBUFSIZE   64
#define SCANBUFDELTA   4

/****************************************************************************/

#define KUNFIGROOT   "/etc/root.kunf"
#define KUNFIGENV    "KUNFIG"

/****************************************************************************/

#define KUNFLOG       LOG_PID|LOG_USER|LOG_ERR
#define KUNFWLOG      LOG_PID|LOG_USER|LOG_WARNING

/****************************************************************************/

#define KUNFIGEXIT     5

/****************************************************************************/

#define KUNFMAXDEAPTH 32

/****************************************************************************/

#define KUNFSTACK     32

/****************************************************************************/
/* Fiddling the values below should only happen if you are fixing lib code **/

#define KUNFIGNOTHING    0x00

#define KUNFIGDOWN       0x01
#define KUNFIGUNKNOWN    0x02
#define KUNFIGFAILED     0x04
#define KUNFIGPLAIN      0x08

#define KUNFIGSTARTINC   0x10
#define KUNFIGENDINC     0x20
#define KUNFIGINC        0x30

#define KUNFIGDIRTY      0x40

#define KUNFIGHASRAW     0x80

/****************************************************************************/

int     _kkunfig_startescape ();
char   *_kkunfig_doescape    (char *str);
int     _kkunfig_quitescape  ();
KITEM  *_kkunfig_new         (char *name, char *value, char *desc, unsigned flags);
int     _kkunfig_free        (KITEM *ptr);
int     _kkunfig_dump        (KITEM *top);
int     _kkunfig_insert      (KITEM *child, KITEM *parent);
KITEM  *_kkunfig_build       (char *fname, KITEM *top);
int     _kkunfig_escapeprint (char *str, FILE *fp);
int     _kkunfig_writeinclude(KITEM *include);

/****************************************************************************/

int     _kkunfig_startscan  ();
char   *_kkunfig_scan       (FILE *fp);
int    *_kkunfig_quitscan   ();

/****************************************************************************/

extern unsigned int _kkunfig_flags;

/****************************************************************************/

#endif

