/*** This file is copyrighted (c) and may only be used in terms of the LGPL ***/

#include <stdio.h>
#include <stdlib.h>

#include <syslog.h>

#include "kunf.h"
#include "internal_kunf.h"


char     *_kkunfig_scanbuf=NULL;
unsigned  _kkunfig_scanbufsize=0;
char      _kkunfig_errorbuf[2];

int _kkunfig_startscan(){

#ifdef TRACE
fprintf(stderr,"startscan(): Starting\n");
#endif

  _kkunfig_scanbuf=(char *)malloc(sizeof(char)*SCANBUFSIZE);
  _kkunfig_scanbufsize=SCANBUFSIZE;

  if(_kkunfig_scanbuf==NULL){
#ifdef TRACE
fprintf(stderr,"startscan(): Could not allocate RAM\n");
#endif
if(_kkunfig_flags&KUNFIG_OPEN_LOGERRORS)syslog(KUNFLOG,"kunfig: Could not allocate RAM");
if(_kkunfig_flags&KUNFIG_OPEN_PRINTERRORS)fprintf(stderr,"kunfig: Could not allocate RAM\n");
if(_kkunfig_flags&KUNFIG_OPEN_EXITONERRORS)exit(KUNFIGEXIT);
kunfig_error=kunfig_error|KUNFIG_ERROR_MALLOC;
    return 1;
  }

  return 0;
}

char *_kkunfig_scan(FILE *fp){
  int      state=1;
  int   oldstate=1;
  unsigned index=0;
  int       inchar;

  while(state){
    inchar=fgetc(fp);

    if(index>_kkunfig_scanbufsize-3){
#ifdef TRACE
fprintf(stderr,"scan(): Resizing buffer from <%u> to <%u>\n",_kkunfig_scanbufsize,SCANBUFDELTA*(index+3));
#endif
      _kkunfig_scanbufsize=SCANBUFDELTA*(index+3);
      _kkunfig_scanbuf=realloc(_kkunfig_scanbuf,sizeof(char)*_kkunfig_scanbufsize);
      if(_kkunfig_scanbuf==NULL){
#ifdef TRACE
fprintf(stderr,"scan(): Could not realloate to <%u>\n",_kkunfig_scanbufsize);
#endif
        kunfig_error=kunfig_error|KUNFIG_ERROR_MALLOC;
if(_kkunfig_flags&KUNFIG_OPEN_LOGERRORS)syslog(KUNFLOG,"kunfig: Could not reallocate RAM");
if(_kkunfig_flags&KUNFIG_OPEN_PRINTERRORS)fprintf(stderr,"kunfig: Could not reallocate RAM\n");
if(_kkunfig_flags&KUNFIG_OPEN_EXITONERRORS)exit(KUNFIGEXIT);
kunfig_error=kunfig_error|KUNFIG_ERROR_MALLOC;
        _kkunfig_errorbuf[0]='\0';
        return _kkunfig_errorbuf;
      }
    }

    switch(state){
       case 1 :
         switch(inchar){
           case '[' :
           case ']' :
           case '>' :
           case '<' :
           case ':' :
           case '=' :
             _kkunfig_scanbuf[0]=inchar;
             _kkunfig_scanbuf[1]='\0';
             state=0;
           break;
           case EOF :
             ungetc(inchar,fp);
             _kkunfig_scanbuf[0]='\0';
             if(ferror(fp)){
if(_kkunfig_flags&KUNFIG_OPEN_LOGERRORS)syslog(KUNFLOG,"kunfig: Read error off stream");
if(_kkunfig_flags&KUNFIG_OPEN_PRINTERRORS)fprintf(stderr,"kunfig: Read error off stream\n");
if(_kkunfig_flags&KUNFIG_OPEN_EXITONERRORS)exit(KUNFIGEXIT);
               kunfig_error=kunfig_error|KUNFIG_ERROR_EOF;
             }
             state=0;
           break;
           case ' ' :
           case '\t':
           case '\n':
             /* state=1 */
           break;
           case '"' :
             state=3; 
           break;
           case '\\':
             state=4;
             oldstate=2;
           break;
           case '#' :
             state=5;
           break;
           default  :
             _kkunfig_scanbuf[index++]=inchar;
             state=2;
           break;
         }
       break;
       case 2 :
         switch(inchar){
           case '\t':
           case '\n':
           case ' ' :
             state=0;
             _kkunfig_scanbuf[index]='\0';
           break;
           case EOF :
             state=0;
             _kkunfig_scanbuf[index]='\0';
             if(ferror(fp)){
if(_kkunfig_flags&KUNFIG_OPEN_LOGERRORS)syslog(KUNFLOG,"kunfig: Read error off stream");
if(_kkunfig_flags&KUNFIG_OPEN_PRINTERRORS)fprintf(stderr,"kunfig: Read error off stream\n");
if(_kkunfig_flags&KUNFIG_OPEN_EXITONERRORS)exit(KUNFIGEXIT);
               kunfig_error=kunfig_error|KUNFIG_ERROR_EOF;
             }
             ungetc(inchar,fp);
           break;
           case '[' :
           case ']' :
           case '>' :
           case '<' :
           case ':' :
           case '=' :
             state=0;
             _kkunfig_scanbuf[index]='\0';
             ungetc(inchar,fp);
           break;
           case '\\':
             oldstate=2;
             state=4;
           break;
           default  :
             _kkunfig_scanbuf[index++]=inchar;
           break;
         }
       break;
       case 3 :
         switch(inchar){
           case '\\':
             oldstate=3;
             state=4;
           break;
           case '"' :
             state=0;
             _kkunfig_scanbuf[index]='\0';
           break;
           case EOF :
             state=0;
             _kkunfig_scanbuf[index]='\0';
             ungetc(inchar,fp);
             if(ferror(fp)){
if(_kkunfig_flags&KUNFIG_OPEN_LOGERRORS)syslog(KUNFLOG,"kunfig: Read error off stream");
if(_kkunfig_flags&KUNFIG_OPEN_PRINTERRORS)fprintf(stderr,"kunfig: Read error off stream\n");
if(_kkunfig_flags&KUNFIG_OPEN_EXITONERRORS)exit(KUNFIGEXIT);
               kunfig_error=kunfig_error|KUNFIG_ERROR_EOF;
             }
           break;
           default  :
             _kkunfig_scanbuf[index++]=inchar;
           break;
         }
       break;
       case 4 :
         switch(inchar){
           case EOF :
             state=0;
             _kkunfig_scanbuf[index]='\0';
             ungetc(inchar,fp);
             if(ferror(fp)){
if(_kkunfig_flags&KUNFIG_OPEN_LOGERRORS)syslog(KUNFLOG,"kunfig: Read error off stream");
if(_kkunfig_flags&KUNFIG_OPEN_PRINTERRORS)fprintf(stderr,"kunfig: Read error off stream\n");
if(_kkunfig_flags&KUNFIG_OPEN_EXITONERRORS)exit(KUNFIGEXIT);
               kunfig_error=kunfig_error|KUNFIG_ERROR_EOF;
             }
           break;
           case '\\':
             _kkunfig_scanbuf[index++]='\\';
           break;
           case '\n':
           break;
           case 'n' :
             _kkunfig_scanbuf[index++]='\n';
           break;
           case 'r' :
             _kkunfig_scanbuf[index++]='\r';
           break;
           case 't' :
             _kkunfig_scanbuf[index++]='\t';
           break;
           case 'f' :
             _kkunfig_scanbuf[index++]='\f';
           break;
           case 'a' :
             _kkunfig_scanbuf[index++]='\a';
           break;
           case '"' :
             _kkunfig_scanbuf[index++]='"';
           break;
           case '%' :
             _kkunfig_scanbuf[index++]='%';
             _kkunfig_scanbuf[index++]='%';
           break;
         }
         state=oldstate;
       break;
       case 5 :
         switch(inchar){
           case EOF :
           break;
           case '\n':
             state=1;
           break;
         }
       break;
    }
  }

#ifdef TRACE
fprintf(stderr,"scan(): Got a token <%s> with index at <%u> bytes\n",_kkunfig_scanbuf,index);
#endif

  return _kkunfig_scanbuf;
}

int  *_kkunfig_quitscan(){

#ifdef TRACE
fprintf(stderr,"quitscan(): Shutting down\n");
#endif

  if((_kkunfig_scanbuf!=NULL)&&(_kkunfig_scanbufsize>0)){
    free(_kkunfig_scanbuf);
    _kkunfig_scanbuf=NULL;
    _kkunfig_scanbufsize=0;
  }

#ifdef TRACE
fprintf(stderr,"quitscan(): Completed Shutdown\n");
#endif

  return 0;
}

#ifdef BOOTSTRAP

unsigned int kunfig_error;

int main(){

  char *ptr;
  _kkunfig_startscan();

  do{
    ptr=_kkunfig_scan(stdin);
    fprintf(stderr,"<%s>",ptr);
  }while(ptr!=NULL&&ptr[0]!='\0');

  _kkunfig_quitscan();
  return 0;
}
#endif
